<script setup lang="ts">
import { useMemberStore } from '@/stores/member'
import { useReceiptStore } from '@/stores/receipt'
import { ref } from 'vue'
const divreceipItems = ref<HTMLLIElement | null>(null)
const memberStore = useMemberStore()
const receiptStore = useReceiptStore()
const formatDate = (dateString: any): string => {
  if (!dateString) return ''

  const options: Intl.DateTimeFormatOptions = {
    year: 'numeric',
    month: 'numeric',
    day: 'numeric',
    hour: 'numeric',
    minute: 'numeric'
  }

  const formattedDate = new Date(dateString).toLocaleString('en-US', options)

  return formattedDate
}
const handleCashClick = () => {
  receiptStore.setPaymentType('cash')
  receiptStore.receipt!.receivedAmount = 0
}

const handleQRCodeClick = () => {
  receiptStore.setPaymentType('qrcode')
  receiptStore.generatePromptPay()
}
</script>
<template>
  <v-dialog v-model="receiptStore.receiptDialog" persistent width="auto">
    <v-card style="background-color: #ffffff; font-family: 'Kanit'">
      <h1 style="text-align: center">
        Confirm Order
        <v-img src="src\assets\latte.png" height="200"></v-img>
      </h1>

      <v-card-text>
        <v-container>
          <table>
            <th>
              <v-row no-gutters style="margin-left: 10%; margin-right: auto; text-align: left">
                <v-divider></v-divider>
                <v-col cols="6">Employee</v-col>
                <v-col cols="6">{{ receiptStore.receipt?.user?.fullName }}</v-col>
                <v-col cols="6">Date</v-col
                ><v-col cols="6">{{ formatDate(receiptStore.receipt?.created) }}</v-col>
                <v-col cols="6">Member</v-col
                ><v-col cols="6">{{
                  receiptStore.receipt?.member?.name ? receiptStore.receipt?.member?.name : '-'
                }}</v-col>
                <v-col cols="12">
                  <v-divider></v-divider>
                  <v-row>
                    <v-col cols="4" style="margin-left: 5%"><strong>Name</strong></v-col>
                    <v-col cols="2"><strong>Qty</strong></v-col>
                    <v-col cols="2" style="margin-left: 5%"><strong>Price</strong></v-col>
                  </v-row>
                  <v-row v-for="item in receiptStore.receiptItems" :key="item.productId">
                    <v-col cols="4" style="margin-left: 5%">{{ item.name }}</v-col>
                    <v-col cols="2">{{ item.qty }}</v-col>
                    <v-col cols="2" style="margin-left: 5%">{{ item.price * item.qty }}</v-col>
                  </v-row>
                </v-col>
                <v-divider></v-divider>
                <v-col cols="6">Total quantity :</v-col
                ><v-col cols="6">{{ receiptStore.receipt?.qty + ' unit' }}</v-col>
                <v-col cols="6">Total :</v-col
                ><v-col cols="6">{{ receiptStore.receipt?.total + ' ฿' }}</v-col>
                <v-col cols="6">MemberDiscount :</v-col
                ><v-col cols="6">{{ '-' + receiptStore.receipt?.memberDiscount + ' ฿' }}</v-col>
                <v-col cols="6">PromotionDiscount :</v-col
                ><v-col cols="6">{{ receiptStore.receipt?.promotionDiscount + ' ฿' }}</v-col>
                <v-col cols="6">Total Net :</v-col
                ><v-col cols="6">{{ receiptStore.receipt?.totalNet + ' ฿' }}</v-col>
                <v-divider></v-divider>
              </v-row>
            </th>
            <th>
              <h2>Payment Type</h2>
              <v-card-text>
                <v-row class="d-flex justify-center">
                  <v-col cols="12" sm="7">
                    <v-sheet
                      width="180"
                      height="100"
                      elevation="3"
                      @click="handleCashClick"
                      :style="{
                        backgroundColor: receiptStore.paymentType === 'cash' ? '#c9c9c9' : '#ffffff'
                      }"
                    >
                      Cash
                      <v-img src="src\assets\money.png" height="70"></v-img>
                    </v-sheet>
                  </v-col>
                  <v-col cols="12" sm="7">
                    <v-sheet
                      width="180"
                      height="100"
                      elevation="3"
                      @click="handleQRCodeClick"
                      :style="{
                        backgroundColor:
                          receiptStore.paymentType === 'qrcode' ? '#c9c9c9' : '#ffffff'
                      }"
                    >
                      QRCode
                      <v-img src="src\assets\qr.png" height="70"> </v-img>
                    </v-sheet>
                  </v-col>
                </v-row>
                <v-col v-if="receiptStore.paymentType === 'cash'">
                  <v-divider></v-divider>
                  <v-row>
                    <v-col cols="6">Total :</v-col>
                    <v-col cols="6">{{ receiptStore.receipt?.totalNet }}</v-col>
                  </v-row>
                  <v-row>
                    <v-col cols="6">Cash :</v-col>
                    <v-col cols="6">
                      <v-text-field
                        v-model="receiptStore.receipt!.receivedAmount"
                        outlined
                        label="จำนวนเงิน"
                        type="number"
                        variant="outlined"
                      ></v-text-field>
                    </v-col>
                  </v-row>
                  <v-row>
                    <v-col cols="6">Change :</v-col>
                    <v-col cols="6">
                      {{ receiptStore.calculateChange() }}
                    </v-col>
                  </v-row>
                </v-col>
                <v-col v-if="receiptStore.paymentType === 'qrcode'">
                  <v-divider></v-divider>
                  <v-row>
                    <v-col cols="6">Total :</v-col>
                    <v-col cols="6">{{ receiptStore.receipt?.totalNet }}</v-col>
                    <v-img v-bind:src="receiptStore.ppQrCode" id="pp_url" width="150" height="146">
                    </v-img>
                  </v-row>
                </v-col>
              </v-card-text>
              <v-card-actions>
                <v-spacer></v-spacer>
                <v-btn
                  rounded="xl"
                  color="white"
                  @click="receiptStore.receiptDialog = false"
                  style="background-color: red; color: red"
                >
                  Cancel
                </v-btn>
                <v-btn
                  rounded="xl"
                  color="white"
                  @click="
                    () => {
                      receiptStore.hidePaymentTypeDialog()
                    }
                  "
                  style="background-color: green; color: white"
                >
                  Confirm
                </v-btn>
              </v-card-actions>
            </th>
          </table>
        </v-container>
      </v-card-text>
    </v-card>
  </v-dialog>
</template>
